<?php
include_once 'lib/db/retrieve.php';
include_once 'lib/db/db_basics.php';
include_once 'lib/auth.php';
include_once 'lib/reference.php';


function display_project_bugs()
{
// Display a list of Bugs for the given projectID


$projectid = $_GET['Project'];


$result = retrieve_bugs_for_project($projectid,"A");

echo "<table border=\"0\"><tbody>\n\n";

while($row = mysql_fetch_array($result, MYSQL_ASSOC))
{
$Desc = urldecode($row['BriefDesc']);

if ($row['Bugstatus'] == "O" )
{
$bugstat = "<div class=\"openbug\">Open - Unassigned</div>";
}

if ($row['Bugstatus'] == "Y" )
{
$bugstat = "<div class=\"closedbug\">Closed - Resolved</div>";
}

if ($row['Bugstatus'] == "S" )
{
$bugstat = "<div class=\"suspendedbug\">Suspended</div>";
}

if ($row['Bugstatus'] == "T" )
{
$bugstat = "<div class=\"testingbug\">Suspended - Sent for Testing</div>";
}


if (!empty($row['AssignedTo']))
{
$bugstat = "<div class=\"assignedbug\">Open - Assigned to Developer</div>";
}




echo "<tr><td><b>{$row['Datelogged']}</b></td><td><a href=\"viewbug.php?BUGID={$row['BugRef']}\">{$row['BriefDesc']}</a></td><td>$bugstat</td></tr>";


}

echo "</tbody></table>\n\n";


}



function display_bug_information()
{
// Display the information for a specific bug

$bugid = $_GET['BUGID'];

echo "<table width=\"100%\"><tbody>";


$result = retrieve_bug_info($bugid);

while($row = mysql_fetch_array($result, MYSQL_ASSOC))
{

if ($row['Bugstatus'] == "O" )
{
$bugstat = "<div class=\"openbug\">Open - Unassigned</div>";
}

if ($row['Bugstatus'] == "Y" )
{
$bugstat = "<div class=\"closedbug\">Closed - Resolved</div>";
}

if ($row['Bugstatus'] == "S" )
{
$bugstat = "<div class=\"suspendedbug\">Suspended</div>";
}

if ($row['Bugstatus'] == "T" )
{
$bugstat = "<div class=\"testingbug\">Suspended - Sent for Testing</div>";
}


if (!empty($row['AssignedTo']))
{
$bugstat = "<div class=\"assignedbug\">Open - Assigned to Developer</div>";
}

$Desc = urldecode($row['BriefDesc']);
$DevNotes = urldecode($row['DeveloperNotes']);

echo "\n<tr><td class=\"tblhead\">Bug Status:</td><td class=\"tblcontent\">$bugstat</td></tr>\n" .
"<tr><td class=\"tblhead\">Bug ID</td><td class=\"tblcontent\">{$row['BugRef']}</td></tr>\n" .
"<tr><td class=\"tblhead\">Date Logged</td><td class=\"tblcontent\">{$row['Datelogged']}</td></tr>\n" .
"<tr><td class=\"tblhead\">Logged By</td><td class=\"tblcontent\">{$row['Loggedby']}</td></tr>\n" .
"<tr><td class=\"tblhead\">Details</td><td class=\"tblcontent\">$Desc</td></tr>\n" .
"<tr><td class=\"tblhead\">Developer</td><td class=\"tblcontent\">{$row['AssignedTo']}</td></tr>\n" .
"<tr><td></td></tr>\n".
"<tr><td class=\"tblhead\">Developer Notes</td><td class=\"tblcontent\">{$row['DeveloperNotes']}</td></tr>\n";


}

echo "</table></tbody>\n\n\n<br><hr>\n";
close_db();

display_bug_comments($bugid);

}


function display_bug_comments($bugid)
{

$result = db_retrieve_bug_comments($bugid);


echo "<br><h3>Bug Comments:</h3>";

while($row = mysql_fetch_array($result, MYSQL_ASSOC))
{

echo '<hr><font size="+1" color="blue">' . "\n {$row['Comment']}\n</font><hr>" .
'<table width="100%"><tbody><tr><td><i><font color="black">' . "{$row['DisplayName']}</font></i>" . 
'</td><td><i><font color="black">' . "{$row['CommentDate']}</font></i></td>" . 
'<td><a href="abuse_report.php?commentID=' . "{$row['CommentRef']}\" rel=\"nofollow\">" . 
'<font color="red">Report Abuse</font></a></td></tr></tbody></table><hr><br />';

}


}




// Display project details
function display_project_details()
{
$projectid = $_GET['Project'];

echo "<table width=\"100%\"><tbody>\n";

$result = db_retrieve_project_details($projectid);

while($row = mysql_fetch_array($result, MYSQL_ASSOC))
{


if ($row['DevelopmentStopped'] == "0" )
{
$devstopped = "No";
}
else
{
$devstopped = "Yes";
}


echo "\n <tr><td class=\"tblhead\">Project ID:</td><td class=\"tblcontent\">{$row['ProjectRef']}</td><td></td><td class=\"tblhead\">Category:</td>" . 
"<td class=\"tblcontent\">$category</td></tr>\n" .
"<tr><td class=\"tblhead\">Development Started:</td><td class=\"tblcontent\">{$row['StartDate']}</td><td></td><td class=\"tblhead\">Development Stopped:</td>" .
"<td class=\"tblcontent\">$devstopped</td></tr>\n" . 
"<tr><td class=\"tblhead\">Maintainer:</td><td class=\"tblcontent\">{$row['Maintainer']}</td><td></td><td></td><td></td></tr>\n" .
"<tr></tr>" . 
"<tr><td class=\"tblhead\">Description:</td><td class=\"tblcontent\" colspan=\"3\">{$row['ProjectDesc']}</td></tr>\n";


}

echo "</tbody></table>\n\n\n\n";
close_db();

}


function generate_project_bug_stats()
{

include 'config/display.php';

if ($display['Bugs'] == 1)
{
$project = $_GET['Project'];

$loggedbugs = db_retrieve_bug_stats("Y","");
$openbugs = db_retrieve_bug_stats("N","O");
$suspendedbugs = db_retrieve_bug_stats("N","S");
$resolved = db_retrieve_bug_stats("N","C");

$outstanding = $suspendedbugs + $openbugs;



echo "\n\n<table  border=\"0\"><tbody>\n" .
"<tr><td class=\"tblhead\">Bugs Logged:</td><td class=\"tblcontent\">" . $loggedbugs . "</td><td class=\"tblcontent\"><a href=\"buglist.php?Project=" .
$project . "\">View.....</a></td></tr>\n" .
"<tr><td class=\"tblhead\">Bugs Outstanding:</td><td class=\"tblcontent\">" . $outstanding . " (" . $suspendedbugs . " Suspended)</td><td></td></tr>\n" .
"<tr><td class=\"tblhead\">Bugs Resolved:</td><td class=\"tblcontent\">" . $resolved . "</td><td></td></tr>\n" .
"</tbody></table>\n\n\n\n";
}
}



// List releases for a given project
function list_releases($count)
{
include 'config/display.php';
if ($display['Releases'] == 1)
{
$project = $_GET['Project'];

$result = db_retrieve_releases($project,"N");
$count = 5;

$rowcount = 0;

echo "\n\n\n<script type=\"text/javascript\">\n" . 
"function LaunchPopuprel(url) {\n" .
"popupWindow = window.open(\n " .
"url,'popUpWindow','height=800,width=600,left=10,top=10,resizable=yes,scrollbars=yes,toolbar=no,menubar=no,location=no,directories=no,status=yes')\n" .
"}\n " .
"</script>\n\n" .
"<table width=\"100%\"><tbody>\n" .
"<tr class=\"tblhead\"><td>Version</td><td>FileName</td><td>File Size</td><td>MD5 Checksum</td><td></td></tr>\n";


while(($row = mysql_fetch_array($result, MYSQL_ASSOC)) && ($rowcount < $count))
{
if (check_user_privileges_file($row['Security']) == 1)
{

$Filesize = round(($row['FileSize']/1024)/1024,2) . " MB";

echo "<tr class=\"tblcontent\" style=\"text-align: center;\"><td>{$row['Version']}</td><td><a href=\"Download.php?id={$row['ReleaseRef']}&type=rel\">" .
"{$row['FileName']}</a></td><td>$Filesize</td><td>{$row['MD5']}</td><td>" .
"<a href=\"JavaScript:LaunchPopuprel('detdocview.php?ref={$row['ReleaseRef']}&type=rel');\">More...</a></td></tr>\n";

$rowcount++;
}
}
echo "</tbody></table>";
}
}



// List releases for a given project
function changelog_summary($count)
{
include 'config/display.php';
if ($display['Changelog'] == 1)
{
$project = $_GET['Project'];

$result = db_retrieve_project_changelog_desc($project);
$count = 5;

$rowcount = 0;

echo "<script type=\"text/javascript\">\n" . 
"function LaunchPopupprojchangelog(url) {\n" .
"popupWindow = window.open(\n " .
"url,'popUpWindow','height=400,width=550,left=10,top=10,resizable=yes,scrollbars=yes,toolbar=no,menubar=no,location=no,directories=no,status=yes')\n" .
"}\n " .
"</script>\n\n" . 


"<table cellpadding=\"5\"><tbody>\n<tr class=\"tblhead\"><td>Date</td><td>Maintainer</td><td style=\"text-align: left;\">Change Details</td></tr>\n";


while(($row = mysql_fetch_array($result, MYSQL_ASSOC)) && ($rowcount < $count))
{

echo "<tr class=\"tblcontent\"><td style=\"text-align: center;\">{$row['Date']}</td><td style=\"text-align: center;\">" .
"{$row['Userref']}</td><td>{$row['ChangeDesc']}</td></tr>\n";


$project = $row['Project'];


$rowcount++;

}
}


echo "<tr><td></td><td></td><td><a href=\"Javascript: LaunchPopupprojchangelog('changelogview.php?Project=$project');\">View Full Changelog</a></td></tr>" .
"\n</tbody></table>\n\n\n\n";

}


// List releases for a given project
function list_documents($count)
{
include 'config/display.php';
if ($display['Documents'] == 1)
{
$project = $_GET['Project'];

$result = db_retrieve_documents($project,"N");
$count = 5;

$rowcount = 0;


echo "<script type=\"text/javascript\">\n" . 
"function LaunchPopupdoc(url) {\n" .
"popupWindow = window.open(\n " .
"url,'popUpWindow','height=800,width=600,left=10,top=10,resizable=yes,scrollbars=yes,toolbar=no,menubar=no,location=no,directories=no,status=yes')\n" .
"}\n " .
"</script>\n\n" .
"<table width=\"100%\"><tbody>\n" .
"<tr class=\"tblhead\"><td>Title</td><td>Version</td><td>Date Submitted</td><td>File Size</td><td></td></tr>\n";


while(($row = mysql_fetch_array($result, MYSQL_ASSOC)) && ($rowcount < $count))
{
if (check_user_privileges_file($row['Security']) == 1)
{
echo "<tr class=\"tblcontent\" style=\"text-align: center;\"><td><a href=\"Download.php?id={$row['DocumentRef']}&type=doc\">{$row['Title']}</a></td>" .
"<td>{$row['Version']}</td><td>{$row['RegisteredDate']}</td><td>{$row['FileSize']}</td><td>" .
"<a href=\"JavaScript:LaunchPopuprel('detdocview.php?ref={$row['DocumentRef']}&type=doc');\">More...</a></td></tr>\n";

$rowcount++;
}
}




echo "</tbody></table>\n\n\n\n";
}
}


// Show full details for a specific release
function detailed_release_view()
{
$release = $_GET['ref'];

$result = db_retrieve_full_release_info($release);



while($row = mysql_fetch_array($result, MYSQL_ASSOC))
{

if (check_user_privileges_file($row['Security']) == 1)
{


echo "<table width=\"100%\"><tbody>\n" .
"<tr><td colspan=\"2\"><hr></td>" .
"<tr><td class=\"tblhead\">Release Information </td></tr>\n" . 
"<tr><td><br /></td></tr>\n" .
"<tr><td class=\"tblhead\">Project:</td><td class=\"tblcontent\">" . get_project_name($row['Project']) . "</td></tr>\n" .
"<tr><td class=\"tblhead\">Release Type:</td><td class=\"tblcontent\">";
translate_release_type_code($row['Patch']);

echo "</td></tr>\n" .
"<tr><td class=\"tblhead\">Release Version:</td><td class=\"tblcontent\">{$row['Version']}</td></tr>\n" .
"<tr><td class=\"tblhead\">License:</td><td class=\"tblcontent\">";

translate_license_code($row['License']);

echo "</td></tr>\n" .
"<tr><td class=\"tblhead\">Security Setting:</td><td class=\"tblcontent\">";
translate_file_sec_codes($row['Security']);
echo "</td></tr>\n" .


"<tr><td><br /></td></tr>\n" .
"<tr><td colspan=\"2\"><hr></td></tr>\n" .
"<tr><td class=\"tblhead\">Upload Information </td></tr>\n" . 
"<tr><td><br /></td></tr>\n" .
"<tr><td class=\"tblhead\">Uploaded By:</td><td class=\"tblcontent\">{$row['User']}</td></tr>\n" .
"<tr><td class=\"tblhead\">Uploaded Date:</td><td class=\"tblcontent\">{$row['RegisteredDate']}</td></tr>\n" .

"<tr><td><br /><br /></td></tr>\n" .
"<tr><td colspan=\"2\"><hr></td></tr>\n" .
"<tr><td class=\"tblhead\">File Information </td></tr>\n" . 
"<tr><td><br /></td></tr>\n" .
"<tr><td class=\"tblhead\">File Name:</td><td class=\"tblcontent\"><a href=\"Download.php?id={$row['ReleaseRef']}&type=rel\">{$row['FileName']}</a></td></tr>\n" .
"<tr><td class=\"tblhead\">File Size:</td><td class=\"tblcontent\">{$row['FileSize']}</td></tr>\n" .
"<tr><td class=\"tblhead\">File Type:</td><td class=\"tblcontent\">{$row['MIMEType']}</td></tr>\n" .
"<tr><td class=\"tblhead\">MD5:</td><td class=\"tblcontent\">{$row['MD5']}</td></tr>\n" .


"<tr><td><br /><br /></td></tr>\n" .
"<tr><td colspan=\"2\"><hr></td></tr>\n" .
"<tr><td class=\"tblhead\">Notes </td></tr>\n" . 
"<tr><td><br /></td></tr>\n" .



"<tr><td colspan=\"2\">{$row['Notes']}</td></tr>\n" .

"</tbody></table>\n\n\n\n";

}
else
{
echo "Insufficient Privileges";

}
}

close_db();
}

// Show full details for a specific release
function detailed_document_view()
{
$document = $_GET['ref'];

$result = db_retrieve_full_document_info($document);



while($row = mysql_fetch_array($result, MYSQL_ASSOC))
{

if (check_user_privileges_file($row['Security']) == 1)
{


echo "<table width=\"100%\"><tbody>\n" .
"<tr><td colspan=\"2\"><hr></td>" .
"<tr><td class=\"tblhead\">Document Information </td></tr>\n" . 
"<tr><td><br /></td></tr>\n" .
"<tr><td class=\"tblhead\">Project:</td><td class=\"tblcontent\">" . get_project_name($row['Project']) . "</td></tr>\n" .
"<tr><td class=\"tblhead\">Title:</td><td class=\"tblcontent\">{$row['Title']}</td></tr>\n" .
"<tr><td class=\"tblhead\">Document Version:</td><td class=\"tblcontent\">{$row['Version']}</td></tr>\n" .
"<tr><td class=\"tblhead\">License:</td><td class=\"tblcontent\">";

translate_license_code($row['License']);
echo "</td></tr>\n" .
"<tr><td class=\"tblhead\">Description:</td><td class=\"tblcontent\">{$row['Description']}</td></tr>\n" .
"<tr><td class=\"tblhead\">Security Setting:</td><td class=\"tblcontent\">";

translate_file_sec_codes($row['Security']);
echo "</td></tr>\n" .


"<tr><td><br /></td></tr>\n" .
"<tr><td colspan=\"2\"><hr></td></tr>\n" .
"<tr><td class=\"tblhead\">Upload Information </td></tr>\n" . 
"<tr><td><br /></td></tr>\n" .
"<tr><td class=\"tblhead\">Uploaded By:</td><td class=\"tblcontent\">{$row['User']}</td></tr>\n" .
"<tr><td class=\"tblhead\">Uploaded Date:</td><td class=\"tblcontent\">{$row['RegisteredDate']}</td></tr>\n" .

"<tr><td><br /><br /></td></tr>\n" .
"<tr><td colspan=\"2\"><hr></td></tr>\n" .
"<tr><td class=\"tblhead\">File Information </td></tr>\n" . 
"<tr><td><br /></td></tr>\n" .
"<tr><td class=\"tblhead\">File Name:</td><td class=\"tblcontent\"><a href=\"Download.php?id={$row['DocumentRef']}&type=doc\">{$row['FileName']}</a></td></tr>\n" .
"<tr><td class=\"tblhead\">File Size:</td><td class=\"tblcontent\">{$row['FileSize']}</td></tr>\n" .
"<tr><td class=\"tblhead\">File Type:</td><td class=\"tblcontent\">{$row['MIMEType']}</td></tr>\n" .


"<tr><td><br /><br /></td></tr>\n" .
"<tr><td colspan=\"2\"><hr></td></tr>\n" .



"</tbody></table>\n\n\n\n";

}
else
{
echo "Insufficient Privileges";

}
}
close_db();

}


function display_license_information()
{
$license = $_GET['ref'];

$result = db_retrieve_license_name($license);

while($row = mysql_fetch_array($result, MYSQL_ASSOC))
{


$licensetext = nl2br($row['LicenseText']);

echo "<script language=\"javascript\">\n" . 
"function togglelicense() {\n" .
"var ele = document.getElementById(\"licensetext\");\n" .
"var text = document.getElementById(\"displayLicense\");\n" . 
"if(ele.style.display == \"block\") {\n" . 
"ele.style.display = \"none\";\n" . 
"text.innerHTML = \"Show License Text\";\n" .
"}\n" . 
"else {\n " .
"ele.style.display = \"block\";\n" .
"text.innerHTML = \"Hide License Text\";\n" .
"}\n" .
"}\n" . 
"</script>\n" .


"<br /><br />\n" .
"<table width=\"100%\"><tbody>\n" .
"<tr><td class=\"tblhead\">License Name:</td><td class=\"tblcontent\">{$row['LicenseName']}</td></tr>\n" .
"<tr><td class=\"tblhead\">License Description:</td><td class=\"tblcontent\">{$row['LicenseName']}</td></tr>\n" .
"<tr><td></td><td class=\"tblcontent\"><a id=\"displayLicense\" href=\"Javascript:togglelicense();\">Show full License text</a></td></tr>\n" .
"<tr><td colspan=\"2\" align=\"justify\"><div id=\"licensetext\" style=\"display: none\">$licensetext</div></td></tr>\n\n" .
"</tbody></table>\n\n\n";



}

close_db();

}



function display_project_changelog()
{

$project = $_GET['Project'];
$result = db_retrieve_project_changelog($project);


echo "<table width=\"100%\"><tbody>\n" .
"<tr class=\"tblhead\"><td>Date</td><td>Maintainer</td><td style=\"text-align: left;\">Change</td></tr>";

 
while($row = mysql_fetch_array($result, MYSQL_ASSOC))
{


echo "<tr class=\"tblcontent\"><td style=\"text-align: center;\">{$row['Date']}</td><td style=\"text-align: center;\">{$row['Userref']}</td><td>{$row['ChangeDesc']}</td></tr>\n";



}
echo "</tbody></table>\n";

close_db();
}




function display_outstanding_tasks()
{

if (empty($_POST['Project']))
{
$project = $_GET['Project'];
}
else
{
$project = $_POST['Project'];
}
$result = db_retrieve_tasks_full($project,"N");

echo "<table width=\"100%\"><tbody>\n" .
"<tr class=\"tblhead\"><td>Date</td><td>Task</td><td>Scheduled By</td><td></td></tr>\n";

while($row = mysql_fetch_array($result, MYSQL_ASSOC))
{

echo "<tr><td>{$row['Date']}</td><td>{$row['Task']}</td><td>{$row['Userref']}</td><td>";

$privset = check_user_priviliges_access("D");

if ($privset == 1)
{


echo "<form action=\"tasks.php\" method=\"post\"><input type=\"hidden\" name=\"Project\" value=\"" . $project .
"\"><input type=\"hidden\" name=\"Taskref\"" .
"value=\"{$row['TaskRef']}\"><input type=\"hidden\" value=\"del\" name=\"action\">" .
"<input type=\"submit\" value=\"Mark Complete\"></form>";

}

echo "</td></tr>\n";


}
echo "</tbody></table>\n";


}







// List releases for a given project
function display_outstanding_tasks_summary($count)
{
include 'config/display.php';
if ($display['Tasks'] == 1)
{
$project = $_GET['Project'];

$result = db_retrieve_tasks_full($project,"Y");
$count = 5;

$rowcount = 0;


echo "<script type=\"text/javascript\">\n" . 
"function LaunchPopupTask(url) {\n" .
"popupWindow = window.open(\n " .
"url,'popUpWindow','height=800,width=1000,left=10,top=10,resizable=yes,scrollbars=yes,toolbar=no,menubar=no,location=no,directories=no,status=yes')\n" .
"}\n " .
"</script>\n\n" .
"<table width=\"100%\"><tbody>\n" .
"<tr class=\"tblhead\"><td>Date</td><td>Task</td><td>Scheduled By</td><td></td></tr>\n";


while(($row = mysql_fetch_array($result, MYSQL_ASSOC)) && ($rowcount < $count))
{

echo "<tr style=\"text-align: center;\"><td>{$row['Date']}</td><td>{$row['Task']}</td><td>{$row['Userref']}</td><td>" .
"</tr>\n";

$rowcount++;

}


echo "<tr><td></td><td><a href=\"JavaScript: LaunchPopupTask('tasks.php?Project=$project');\">View All Tasks</a></td><td></td></tr>\n" . 
"</tbody></table>\n\n\n\n";


}
}



//--------------------------------------------------------------------------------------------------//
//				One Shot functions


function get_project_name($projectid)
{

$result = db_get_project_name($projectid);
while($row = mysql_fetch_array($result, MYSQL_ASSOC))
{
return $row['ProjectName'];
}
}



?> 
